/*###############################################################################
#                                                                               #
# Project:     mp3                                                              #
#                                                                               #
# Description: Very simple TAP to play all mp3 files randomly                   #
#              Keys: "Stop" ends the program, without menu                      #
#                    "Forward" or "Next" jumps to next mp3                      #
#                                                                               #
# Author:      Satschssel                                                      #
# Adjustments: xyzzyx (TMS changes)                                             #
#                                                                               #
# Comments:    Use it at your own risk                                          #
#                                                                               #
# History:                                                                      #
# Version    When         Who                            What                   #
# ------- ----------- -------------  ------------------------------------------ #
#  v1.0   07.05.2004  Satschssel    First release                              #
#  v1.1   18.08.2009  xyzzyx         adjustment for TMS, no double songs (TMS), #
#                                    really find all files & directories (TMS)  #
#  v1.1a  11.11.2009  xyzzyx         bugfix: due to missing new gettick for     #
#                                    starttick never found a second file        #
#  v1.1b  15.08.2010  xyzzyx         support for TAPtoDate                      #
#  v1.1c  18.11.2010  xyzzyx         added FireBirdLib & KeyTranslate           #
#                                                                               #
###############################################################################*/


// xyzzyx 090818
#ifdef _TMS_
#include <string.h>
#endif

#include <stdlib.h>
#include <math.h>
#include "tap.h"
// xyzzyx 101118
#ifdef _TMS_
#include "libFireBird.h"   // tested with FireBirdLib version "2010-11-14"
#endif


// xyzzyx 090818
#define TRACE(a) //a 																						// Trace aktiv, wenn letztes "a" nicht kommentiert ist
#define PGM_NAME "mp3"
#define PGM_VERS "V1.1c"
#define PGM_FULL PGM_NAME " " PGM_VERS

// xyzzyx 090818
#ifdef _TMS_
#define MP3_DIR "MP3Files"
#else
#define MP3_DIR "MP3"
#endif

#define ID_mp3 0x80000105

TAP_ID( 0x81AFFE11 );																					// xyzzyz 100815 changed
TAP_PROGRAM_NAME(PGM_FULL); 																	// xyzzyx 090818
TAP_PROGRAM_VERSION(PGM_VERS);																// xyzzyx 100815
TAP_AUTHOR_NAME("xyzzyx (Satschssel)"); 											// xyzzyx 090818
TAP_DESCRIPTION("Play mp3 files randomly");										// xyzzyx 090818
TAP_ETCINFO(__DATE__);

bool exitFlag = FALSE;
bool bPlayingMP3 = FALSE;
bool showInfo = FALSE;                                        // xyzzyx 091111
char* name;							// stores width of message-text
dword starttick; 				// so we know how long we waited			// xyzzyx 090818
char buf[30];

// xyzzyx 090818
#ifdef _TMS_
dword last = 0; // last random number
#endif

// xyzzyx 101118
#ifndef _TMS_
void ShowMessageWin (char* lpMessage, char* lpMessage1)
{
/* xyzzyx 090818
#ifdef _TMS_
	int rgn;							// stores rgn-handle for osd
	int w;

	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, FALSE );		// create rgn-handle
	w = TAP_Osd_GetW( lpMessage, 0, FNT_Size_1926 ) + 10;		// calculate width of message
	if (TAP_Osd_GetW( lpMessage1, 0, FNT_Size_1926 ) + 10>w)
	{
		w = TAP_Osd_GetW( lpMessage1, 0, FNT_Size_1926 ) + 10;	// calculate width of message
	}
	if (w > 720) w = 720;						// if message is to long
	TAP_Osd_FillBox(rgn, (720-w)/2-5, 265, w+10, 62, COLOR_White );	// draw background-box for border
	TAP_Osd_PutS(rgn, (720-w)/2, 270, (720+w)/2, lpMessage,		// show message
		COLOR_White, COLOR_DarkBlue, 0, FNT_Size_1926, FALSE, ALIGN_CENTER);
	TAP_Osd_PutS(rgn, (720-w)/2, 270+26, (720+w)/2, lpMessage1,		// show message
		COLOR_White, COLOR_DarkBlue, 0, FNT_Size_1926,FALSE, ALIGN_CENTER);
	TAP_Osd_Sync();
	TAP_Delay(250);								// show it for 1.4 seconds
	TAP_Osd_Delete(rgn);					// release rgn-handle
	TAP_Osd_Sync();
#else */
	int rgn;							// stores rgn-handle for osd
	dword w;

	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, FALSE );		// create rgn-handle
	w = TAP_Osd_GetW( lpMessage, 0, FNT_Size_1926 ) + 10;		// calculate width of message
	if (TAP_Osd_GetW( lpMessage1, 0, FNT_Size_1926 ) + 10>w)
	{
		w = TAP_Osd_GetW( lpMessage1, 0, FNT_Size_1926 ) + 10;	// calculate width of message
	}
	if (w > 720) w = 720;						// if message is to long
	TAP_Osd_FillBox(rgn, (720-w)/2-5, 265, w+10, 62, RGB(19,19,19) );	// draw background-box for border
	TAP_Osd_PutS(rgn, (720-w)/2, 270, (720+w)/2, lpMessage,		// show message
		RGB(31,31,31), RGB(3,5,10), 0, FNT_Size_1926, FALSE, ALIGN_CENTER);
	TAP_Osd_PutS(rgn, (720-w)/2, 270+26, (720+w)/2, lpMessage1,		// show message
		RGB(31,31,31), RGB(3,5,10), 0, FNT_Size_1926,FALSE, ALIGN_CENTER);
	TAP_Delay(500);							// show it for 2.8 seconds
	TAP_Osd_Delete(rgn);					// release rgn-handle
//#endif
}
#endif

bool isMP3( char *name )
{
    static char tmp[128];

    strcpy( tmp, name );
    // strlwr( tmp );																					// xyzzyx 090818
    if( strcmp( tmp + strlen(tmp) - 4, ".mp3" ) == 0 )
        return TRUE;
    else
        return FALSE;
}

void toRoot(){
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
	TAP_Hdd_ChangeDir("..");
}

void play(char* mp3){
	int ok;
// xyzzyx 090818
#ifdef _TMS_
	static TYPE_FolderEntry*    _pFileList;
	UNUSED(_pFileList);
	TYPE_FolderEntry file;
	int anzahl=0;
	dword zufall=0;
#else
	TYPE_File file;
	int anzahl=0;
	int zufall=0;
#endif

	//int sec; 																									// xyzzyx 090818
	//int min;    																							// xyzzyx 090818

// xyzzyx 090818
#ifdef _TMS_
	TAP_Hdd_ChangeDir(mp3);
	anzahl = TAP_Hdd_FindFirst(&file, NULL);

  if (anzahl<1)
	{
		return;
	}

	if (anzahl > 1)
	  while((zufall = (rand() % (anzahl))+1) == last)
	  {
// xyzzyx 101118
#ifdef _TMS_
TRACE( ShowMessageWin(PGM_FULL, "Lied wre doppelt gewesen", NULL, 250); );
#else
TRACE( ShowMessageWin(PGM_FULL, "Lied wre doppelt gewesen"); );// xyzzyx 090818
#endif
	  }

TRACE( TAP_SPrint(buf, "Anzahl: %d, Zufall: %d ", anzahl, zufall); );// xyzzyx 090818
// xyzzyx 101118
#ifdef _TMS_
TRACE( ShowMessageWin(PGM_FULL, buf, NULL, 250); );
#else
TRACE( ShowMessageWin(PGM_FULL, buf); );											// xyzzyx 090818
#endif
	if (zufall > 1)
		while(TAP_Hdd_FindNext(&file)!=zufall)
		{
		}
	if(isMP3(file.name))
	{
		ok = TAP_Hdd_PlayMp3(file.name);
		showInfo = TRUE;                                          // xyzzyx 091111
		last = zufall; 																						// xyzzyx 090818
		toRoot(); //etwas Zeit sparen und hier schon wieder zu Root wechseln
	}
	else
	{
		play(file.name);
	}
#else
	TAP_Hdd_ChangeDir(mp3);
	anzahl = TAP_Hdd_FindFirst(&file)-2;
	if(anzahl<1){
		return;
	}
	zufall = 2+rand() % anzahl;
	while(TAP_Hdd_FindNext(&file)!=zufall){
	//	ShowMessageWin("",file.name);
	}
	if(isMP3(file.name)){
		ok = TAP_Hdd_PlayMp3(file.name);
		showInfo = TRUE;                                          // xyzzyx 091111
		toRoot(); //etwas Zeit sparen und hier schon wieder zu Root wechseln


	} else {
		play(file.name);
	}
#endif

}
dword TAP_EventHandler( word event, dword param1, dword param2 )
{
// xyzzyx 090818
#ifdef _TMS_
	UNUSED(param2);
#endif

	if( event == EVT_RBACK ) // Radio/MP3 background change event.
	{
 		if( param1 == 0 ) // mp3 background start
		{
			bPlayingMP3 = TRUE;
		}
		if( param1 == 1 ) // mp3 background end
		{
			bPlayingMP3 = FALSE;
		}

// xyzzyx 090818
#ifdef _TMS_
		return 0xFF; // handled by tap
#else
		return 0; // handled by tap
#endif
	}
 	else if( event == EVT_IDLE )
	{
 		dword state, subState;
		TAP_GetState( &state, &subState );

 		if ( ( state == STATE_Normal ))
  	{
			if(bPlayingMP3==FALSE)
			{
				// xyzzyx 090818
				starttick = TAP_GetTick();                            // xyzzyx 091111
				toRoot();
				play(MP3_DIR); 																				// xyzzyx 090818
				//TAP_Delay(200);
				//TAP_GenerateEvent(EVT_KEY,RKEY_Info,RKEY_Info);
				if (TAP_GetTick() > (starttick + 50) )
				{
					TAP_SPrint(buf, "No mp3 files found in '/%s'. Exiting ...", MP3_DIR);
// xyzzyx 101118
#ifdef _TMS_
					ShowMessageWin(PGM_FULL, buf, NULL, 250);
#else
					ShowMessageWin(PGM_FULL, buf);
#endif
					TAP_Exit();
				}

				return 0;
			}
			else																													// xyzzyx 091111
			{																															// xyzzyx 091111
				if (showInfo)																								// xyzzyx 091111
				{																														// xyzzyx 091111
					TAP_Delay(200);																						// xyzzyx 091111
				  TAP_GenerateEvent(EVT_KEY,RKEY_Info,RKEY_Info);						// xyzzyx 091111
					showInfo = FALSE;																					// xyzzyx 091111
				}																														// xyzzyx 091111
			}																															// xyzzyx 091111
		}

	}


  if( event == EVT_KEY )
  {
    if (param1 == RKEY_Stop)
		{
// xyzzyx 101118
#ifdef _TMS_
TRACE( ShowMessageWin(PGM_FULL, "Exit", NULL, 250); );
#else
TRACE( ShowMessageWin(PGM_FULL, "Exit"); );										// xyzzyx 090818
#endif
// xyzzyx 090818
#ifdef _TMS_
			TAP_GenerateEvent(EVT_KEY,RKEY_Stop,RKEY_Stop);
#endif
			TAP_Exit ();
			return 0;
   	}
    if (param1 == RKEY_Forward || param1 == RKEY_Next  )
		{
			toRoot();
  		play(MP3_DIR); 																					// xyzzyx 090818
			return 0;
   	}
  }
  return param1;
}

int TAP_Main(void)
{
// xyzzyx 101118
#ifdef _TMS_
	KeyTranslate(TRUE, &TAP_EventHandler);
#endif
	srand(starttick = TAP_GetTick());
	toRoot();
	play(MP3_DIR); 																						// xyzzyx 090818
	return 1;

}

